SFML 2.4.2
Classes | Public Member Functions | List of all members
sf::SoundFileReader Class Referenceabstract
Audio module

Abstract base class for sound file decoding. More...

`#include <SoundFileReader.hpp>`

## Classes

struct | Info
| Structure holding the audio properties of a sound file. More...

## Public Member Functions

virtual | ~SoundFileReader ()
| Virtual destructor. More...
virtual bool | open (InputStream &stream, Info &info)=0
| Open a sound file for reading. More...
virtual void | seek (Uint64 sampleOffset)=0
| Change the current read position to the given sample offset. More...
virtual Uint64 | read (Int16 *samples, Uint64 maxCount)=0
| Read audio samples from the open file. More...

## Detailed Description

Abstract base class for sound file decoding.

This class allows users to read audio file formats not natively supported by SFML, and thus extend the set of supported readable audio formats.

A valid sound file reader must override the open, seek and write functions, as well as providing a static check function; the latter is used by SFML to find a suitable writer for a given input file.

To register a new reader, use the sf::SoundFileFactory::registerReader template function.

Usage example:

class MySoundFileReader : public sf::SoundFileReader
{
public:
static bool check(sf::InputStream& stream)
{
// typically, read the first few header bytes and check fields that identify the format
// return true if the reader can handle the format
}
virtual bool open(sf::InputStream& stream, Info& info)
{
// read the sound file header and fill the sound attributes
// (channel count, sample count and sample rate)
// return true on success
}
virtual void seek(sf::Uint64 sampleOffset)
{
// advance to the sampleOffset-th sample from the beginning of the sound
}
virtual sf::Uint64 read(sf::Int16* samples, sf::Uint64 maxCount)
{
// read up to 'maxCount' samples into the 'samples' array,
// convert them (for example from normalized float) if they are not stored
// as 16-bits signed integers in the file
// return the actual number of samples read
}
};
sf::SoundFileFactory::registerReader<MySoundFileReader>();

See also
  sf::InputSoundFile, sf::SoundFileFactory, sf::SoundFileWriter

Definition at line 43 of file SoundFileReader.hpp.

## Constructor & Destructor Documentation

## ◆ ~SoundFileReader()

virtual sf::SoundFileReader::~SoundFileReader | ( |  | ) |

inline virtual

Virtual destructor.

Definition at line 62 of file SoundFileReader.hpp.

## Member Function Documentation

## ◆ open()

virtual bool sf::SoundFileReader::open | ( | InputStream & | stream,
|  | Info & | info
| ) |  |

pure virtual

Open a sound file for reading.

The provided stream reference is valid as long as the SoundFileReader is alive, so it is safe to use/store it during the whole lifetime of the reader.

Parameters

  stream | Source stream to read from
  info | Structure to fill with the properties of the loaded sound

Returns
  True if the file was successfully opened

## ◆ read()

virtual Uint64 sf::SoundFileReader::read | ( | Int16 * | samples,
|  | Uint64 | maxCount
| ) |  |

pure virtual

Read audio samples from the open file.

Parameters

  samples | Pointer to the sample array to fill
  maxCount | Maximum number of samples to read

Returns
  Number of samples actually read (may be less than maxCount)

## ◆ seek()

virtual void sf::SoundFileReader::seek | ( | Uint64 | sampleOffset | ) |

pure virtual

Change the current read position to the given sample offset.

The sample offset takes the channels into account. Offsets can be calculated like this: `sampleNumber * sampleRate * channelCount` If the given offset exceeds to total number of samples, this function must jump to the end of the file.

Parameters

  sampleOffset | Index of the sample to jump to, relative to the beginning

The documentation for this class was generated from the following file:

- SoundFileReader.hpp